/* using 9 I/O pins to control 20 LEDs individually 
 * P1 - P3(2.0)
 * P2 - P5(2.2)
 * P3 - P7(2.4)
 * P4 - P9(4.4)
 * P5 - P11(4.6)
 * P6 - P4(2.1)
 * P7 - P6(2.3)
 * P8 - P8(4.3)
 * P9 - P10(4.5)
 * LED 1-8 are controlled by Sensor 1 on 
 * LED 9-16 are controlled by Sensor 2
 * LED 17-24 are controlled by Sensor 3
 * LED 25-32 are controlled by Sensor 4
 * LED 33-40 are controlled by Sensor 5
 * LED 41-48 are controlled by Sensor 6
 * LED 49-56 are controlled by Sensor 7
 * LED 57-64 are controlled by Sensor 8
 * LED 65-72 are controlled by Sensor 9*/

#include "msp430x22x4.h"

//delay function
void delay (unsigned int n){
	int i;
	for (i=0; i < n; i++) {
		__no_operation();
		__no_operation();
		__no_operation();
	}
}

/*turn on/off LED with an index between 1 and 20 and switch on for a duration
 *equal to interval */
  void control_LED(int index, int interval){
  	int i;
  	int pin_on;
  	int pin_off;

  	pin_on = (index %8 == 0)? (index/8) : (index/8+1);
  	pin_off = (index%8 == 0)? 8: (index%8);
  	pin_off = (pin_off >= pin_on)? (pin_off + 1): pin_off;
  	for (i = 1; i <= 9; i++){
  		if (1 == i){
  			if (pin_on == i){
  				P2DIR |= 0x01;
  				P2OUT |= 0x01;
  			}
  			else if(pin_off == i){
  				P2DIR |= 0x01;
  				P2OUT &= 0xFE;
  			}
  			else {
  				//P2DIR |= 0x01;
  				//P2REN |= 0x01;
  			}
  		}
 		if (2 == i){
 			if (pin_on == i){
 				P2DIR |= 0x04;
 				P2OUT |= 0x04;
 			}
 			else if (pin_off == i){
 				P2DIR |= 0x04;
 				P2OUT &= 0xFB;

 			}
 			else {
 				//P2DIR |= 0x04;
 				//P2REN |= 0x04;
 			}
 		}
 		if (3 == i){
 			if (pin_on == i){
 				P2DIR |= 0x10;
 				P2OUT |= 0x10;
 			}
 			else if (pin_off == i){
 				P2DIR |= 0x10;
 				P2OUT &= 0xEF;
 			}
 			else {
 				//P2DIR &= 0xEF;
 				//P2REN |= 0x10;
 			}
 		}
 		if (4 == i){
 			if(pin_on == i){
 				P4DIR |= 0x10;
 				P4OUT |= 0x10;
 			}
 			else if(pin_off == i){
 				P4DIR |= 0x10;
 				P4OUT &= 0xEF;
 			}
 			else {
 				//P4DIR &= 0xEF;
  				//P4REN |= 0x10;
 			}
 		}
 		if (5 == i){
 			if(pin_on == i){
 				P4DIR |= 0x40;
 				P4OUT |= 0x40;
 			}
 			else if (pin_off == i){
 				P4DIR |= 0x40;
 				P4OUT &= 0xBF;
 			}
 			else {
 				//P4DIR &= 0xBF;
 				//P4REN |= 0x40;
 			}
 		}
 		if (6 == i){
 			if(pin_on == i){
 				P2DIR |= 0x02;
 				P2OUT |= 0x02;
 			}
 			else if (pin_off == i){
 				P2DIR |= 0x02;
 				P2OUT &= 0xFD;
 			}
 			else {}
 		}
 		if (7 == i){
 			if (pin_on == i){
 				P2DIR |= 0x08;
 				P2OUT |= 0x08;
 			}
 			else if (pin_off == i){
 				P2DIR |= 0x08;
 				P2OUT &= 0xF7;
 			}
 			else{}
 		} 
 		if (8 == i){
 			if (pin_on == i){
 				P4DIR |= 0x08;
 				P4OUT |= 0x08;
 			}
 			else if (pin_off == i){
 				P4DIR |= 0x08;
 				P4OUT &= 0xF7;
 			}
 			else {}
 		}
 		if (9 == i){
 			if (pin_on == i){
 				P4DIR |= 0x20;
 				P4OUT |= 0x20;
 			}
 			else if (pin_off == i){
 				P4DIR |= 0x20;
 				P4OUT &= 0xDF;
 			}
 			else {}
 		}
  	}
  	delay(interval);
  	P2DIR = 0x00;
  	P4DIR = 0x00;
  }
  

